# Oct 2010, kyyu
# version 0.2
# description:  This plugin groups and pushpull all 2D faces selected 
#               -change the value "thickness_default", to set the thickness
#               -change to "use_input_box = false", if you don't want a input box
#
# v0.2  added input box
# v0.1  original

require 'sketchup.rb'

def kyyu_group_pushpull_2D_faces
    #### Change these default values manually ####
    thickness_default = 0.25
    use_input_box = true
    ####                                      ####
    
    if use_input_box
        prompts = ["Thickness"]
        defaults = [thickness_default.to_s]
        input = UI.inputbox prompts, defaults, "Push/Pull Thickness"
        ppthick = Sketchup.parse_length(input[0]).to_f
    else ppthick = thickness_default
    end
    puts ppthick
    
    model = Sketchup.active_model
	ent = model.entities
	sel = model.selection
    faces = []
		
	sel.each do |e|
		if e.is_a? Sketchup::Face
            faces.push e
		end
	end   

    Sketchup.active_model.start_operation "Group PushPull 2D Faces"     
	faces.each do |e|
        ent.add_group e
        e.pushpull (-ppthick)
    end
			Sketchup.active_model.commit_operation	
end


if( not file_loaded?('ky_Group_PushPull_2DFaces.rb') )
UI.menu('Plugins').add_item('[ky] Group and PushPull 2D Faces') { kyyu_group_pushpull_2D_faces }
end

file_loaded 'ky_Group_PushPull_2DFaces.rb'


